(******************************************************************
DevoteeĶ̬ô֡

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Jan.30-05, Feb.26, Mar.13, Mar.27, Apr.09-06, Mar.05-09

IMMethodInterceptor: ӿڣʵAOPã
TMMethodInvocationġ
    ݰIIDIDֵ

Mar.05-09   MDCommзֲ
******************************************************************)
unit MDMethod;

interface

Uses
    SysUtils, Classes, TypInfo, IntfInfo, InvRules, MDComm, MIntfReg;

Type

  TMMethodInvocation = Class;

  IMMethodInterceptor = Interface
    Procedure Invoke( const aContext : TMMethodInvocation );
  End;

  TMMethodInvocation = class( TInterfacedObject, IMSerializable )
  private
    FIID    : TGUID;
    FCallID : Integer;
    FMethMD : TIntfMethEntry;
    FParams : Array of Pointer;
    FData   : Array of Byte;
    FRetPtr : Pointer;
    FRetVal : Array [0..15] Of Byte;

    Function  GetParamSize( aIndex : Integer ) : Integer;
    Function  GetParams( aIndex : Integer ) : Variant;
    procedure SetParams(aIndex: Integer; const aValue: Variant);
    function  GetRetVal: Variant;
    procedure SetRetVal(const Value: Variant);
    function  GetParamPtrs(aIndex: Integer): Pointer;

  protected
    //  implements IMSerializable
    Procedure SerializeRead(  Ser : IMSerializer );
    Procedure SerializeWrite( Ser : IMSerializer );
  public
    constructor Create;

    Procedure GenContext( aIntfMD : TIntfMetaData; const aMethNum: Integer;
      const aParams: Pointer; const aResultP : Pointer );
    Procedure Free;

    Property IID    : TGUID          Read FIID;
    Property CallID : Integer        Read FCallID;
    Property MethMD : TIntfMethEntry Read FMethMD;
    Property Params[aIndex : Integer] : Variant Read GetParams Write SetParams;
    Property RetVal : Variant        Read GetRetVal Write SetRetVal;
    Property ParamPtrs[aIndex : Integer] : Pointer Read GetParamPtrs;
    Property RetPtr : Pointer        Read FRetPtr;
  End;

implementation

{ TMMethodInvocation }

const
  MAXINLINESIZE = sizeof(TVarData) + 4;
  TITGUID : TTypeInfo = ( Kind: tkRecord; Name: 'TGUID' );

constructor TMMethodInvocation.Create;
begin
    Inherited Create;
    _AddRef( );
end;

procedure TMMethodInvocation.Free;
begin
  _Release;
end;

//
//  еGenContextǵöˣöͨSerializeReadõ
//
procedure TMMethodInvocation.GenContext(aIntfMD : TIntfMetaData; const aMethNum:
        Integer; const aParams: Pointer; const aResultP : Pointer);
var
  P: Pointer;
  ParamIdx, J, LeftRightOrder: Integer;
begin
  { Get MethodEntry information }
  FIID    := aIntfMD.IID;
  FCallID := aMethNum;
  FMethMD := aIntfMD.MDA[aMethNum];
  SetLength( FParams, FMethMD.ParamCount + 1 );
  P := aParams;
  ParamIdx := 0;

  { Set up the parameter index and left right ordering, }
  { depending on calling convention }
  if FMethMD.CC = ccPascal then
  begin
    ParamIdx := FMethMD.ParamCount - 1;
    LeftRightOrder := -1;
  end else if FMethMD.CC in [ccCdecl, ccStdCall, ccSafeCall]  then
  begin
    ParamIdx := 0;
    LeftRightOrder := 1;
  end else
    LeftRightOrder := 0; { to-do: raise unsupported  }

  if FMethMd.CC <> ccSafeCall then
  begin
    if RetOnStack(FMethMD.ResultInfo) then
    begin
      FRetPtr := Pointer(PInteger(P)^);
      if FMethMD.ResultInfo.Kind = tkVariant then
        IncPtr(P, sizeof(Pointer))
      else
        IncPtr(P, GetStackTypeSize(FMethMD.ResultInfo, FMethMD.CC));
      if FMethMD.CC in [ccCdecl, ccStdCall] then
        IncPtr(P, sizeof(Pointer));   { Step over self  }
    end
    else
      FRetPtr := aResultP;
  end;

  { Walk the parameters, setting pointers to each param's data into }
  { the parameter slots in the context  }
  for  J := 0 to  FMethMD.ParamCount - 1 do
  begin
    //FContext.SetParamPointer(ParamIdx, P);
    FParams[ParamIdx] := P;
    IncPtr( P, GetParamSize( J ) );
    Inc(ParamIdx, LeftRightOrder);
  end;

  if MethMD.CC = ccSafeCall then
    FRetPtr := Pointer(PInteger(P)^);
end;

function TMMethodInvocation.GetParamSize(aIndex : Integer): Integer;
begin
  with FMethMD.Params[aIndex] do
  begin
    if (Info.Kind = tkVariant) and
       (MethMD.CC in [ccCdecl, ccStdCall, ccSafeCall]) and
       not (pfVar in Flags) and
       not (pfOut in Flags) then
    begin
      Result := sizeof(TVarData); { NOTE: better would be to dword-align!! }
    end
    else if IsParamByRef(Flags, Info, MethMD.CC) then
      Result := 4
    else
      Result := GetStackTypeSize(Info, MethMD.CC);
  end;
end;

function TMMethodInvocation.GetParams(aIndex : Integer): Variant;
begin
  Assert( ( aIndex >= 0 ) AND ( aIndex < FMethMD.ParamCount ) );
  Result := GetVariantFromPointer( FMethMD.Params[aIndex].Info,
      FParams[aIndex] );
end;

function TMMethodInvocation.GetParamPtrs(aIndex: Integer): Pointer;
begin
  Result := FParams[aIndex];
end;

procedure TMMethodInvocation.SetParams(aIndex : Integer; const aValue: Variant);
begin
  If Length( FData ) = 0 Then
    SetLength( FData, ( FMethMD.ParamCount + 1 ) * MAXINLINESIZE );
  SetVariantToPointer( FMethMD.Params[aIndex].Info, FParams[aIndex], aValue );
end;

function TMMethodInvocation.GetRetVal: Variant;
begin
  If FMethMD.ResultInfo = Nil Then
    Result := 0
  Else
    Result := GetVariantFromPointer( FMethMD.ResultInfo, FRetPtr )
end;

procedure TMMethodInvocation.SetRetVal(const Value: Variant);
begin
  If FMethMD.ResultInfo <> Nil Then
    SetVariantToPointer( FMethMD.ResultInfo, FRetPtr, Value )
end;

procedure TMMethodInvocation.SerializeRead(Ser : IMSerializer);
var
  i: Integer;
  IntfMD: TIntfMetaData;
  p: Pointer;
  v: Variant;
begin
  If FCallID = 0 Then
  Begin
    Ser.ReadValueCount( );

    FIID := StringToGUID( Ser.ReadValue( @TITGUID ) );
    FCallID := Ser.ReadValue( TypeInfo( Integer ) );

    GetIntfMetaData( GMIntfReg.GetIntfTypeInfo( FIID ), IntfMD, True);
    FMethMD := IntfMD.MDA[FCallID];

    SetLength( FParams, FMethMD.ParamCount + 1 );
    SetLength( FData, ( FMethMD.ParamCount + 1 ) * MAXINLINESIZE );
    p := @FData[0];

    for i := 0 to  FMethMD.ParamCount - 1 do
    Begin
      v := Ser.ReadValue( FMethMD.Params[i].Info );
      FParams[i] := p;
      SetVariantToPointer( FMethMD.Params[i].Info, p, v );
      IncPtr( p, GetParamSize( i ) );
    End;
    FRetPtr := @FRetVal[0];
    Ser.ReadValue( FMethMD.ResultInfo );
//    SetVariantToPointer( FMethMD.ResultInfo, FRetPtr, FValues[FMethMD.ParamCount] );
  End
  Else
  Begin
    Ser.ReadValueCount( );
    Ser.ReadValue( @TITGUID );
    Ser.ReadValue( TypeInfo( Integer ) );

    for i := 0 to  FMethMD.ParamCount - 1 do
    Begin
      v := Ser.ReadValue( FMethMD.Params[i].Info );
      SetVariantToPointer( FMethMD.Params[i].Info, FParams[i], v );
    End;
    PVariant( @FRetVal )^ := Ser.ReadValue( FMethMD.ResultInfo );
    SetVariantToPointer( FMethMD.ResultInfo, FRetPtr, PVariant( @FRetVal )^ );
  End;
end;

procedure TMMethodInvocation.SerializeWrite(Ser : IMSerializer);
var
  i: Integer;
begin
  Ser.WriteValueCount( 0 );
  Ser.WriteValue( @TITGUID, Variant( FIID ) );
  Ser.WriteValue( TypeInfo( Integer ), FCallID );
  for i := 0 to  FMethMD.ParamCount - 1 do
    Ser.WriteValue( FMethMD.Params[i].Info, GetParams( i ) );
  Ser.WriteValue( FMethMD.ResultInfo, GetRetVal( ) );
end;

end.
