(******************************************************************
RTTIʵֵݼԼ򵥵ؽݼ󻯡

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Jan.28-05, Feb.09, Feb.14

TMDataSetProxy: רעݼĶ󻯴
    л/XML־ûܶMSerializԪУĽͨԣ
    شǿ
    TMDataSetProxyʵIMSerializableӿڣдݼл
TMPagedDataSetProxy: ʵַҳݼ
    ʵ IMStateSerializable ӿڣʵֶ״̬־û

Apr.13 ƻ
******************************************************************)
unit MDSPComm;

interface

Uses
  Classes, DB, MDComm;

Type
  TGetRecordCountEvent = Procedure ( Sender : TObject; var aCount : Integer ) Of Object;

{$M+}
  TMDataSetProxy = class(TInterfacedObject, IMSerializable)
  private
    FDataSet  : TDataSet;
    FPropList : TMPropList;
    FLooping  : Boolean;
    
    FOnGetRecordCount: TGetRecordCountEvent;
    
    function  GetFields(aName: String): Variant;
    procedure SetFields(aName: String; const Value: Variant);

  protected
    Procedure BeginEdit;
    Procedure EndEdit;
    Function  GetInteger( aIndex : Integer ) : Integer; Virtual;
    Function  GetFloat(   aIndex : Integer ) : Double;  Virtual;
    Function  GetString(  aIndex : Integer ) : String;  Virtual;
    Function  GetVariant( aIndex : Integer ) : Variant; Virtual;
    Procedure SetInteger( aIndex : Integer; aValue : Integer ); Virtual;
    Procedure SetFloat(   aIndex : Integer; aValue : Double  ); Virtual;
    Procedure SetString(  aIndex : Integer; aValue : String  ); Virtual;
    Procedure SetVariant( aIndex : Integer; aValue : Variant ); Virtual;
    Procedure SerializeRead(  Ser : IMSerializer );
    Procedure SerializeWrite( Ser : IMSerializer );
    Function  DoGetRecordCount( ) : Integer;

  public
    constructor Create( aDataSet : TDataSet );
    destructor  Destroy; override;
    Procedure AfterConstruction; Override;
    Procedure Free;

    function  ForEach : Boolean;

    Property DataSet : TDataSet Read FDataSet;
    Property Fields[aName : String] : Variant Read GetFields Write SetFields;
    Property OnGetRecordCount : TGetRecordCountEvent Read FOnGetRecordCount Write FOnGetRecordCount;
  end;
{$M-}
implementation

{ TMDataSetProxy }

constructor TMDataSetProxy.Create(aDataSet: TDataSet);
begin
  Inherited Create;
  FDataSet := aDataSet;
  FDataSet.Open;
  FLooping := false;
end;

destructor TMDataSetProxy.Destroy;
begin
  FPropList.Free;
  If Assigned( FDataSet ) Then
      FDataSet.Close;
  inherited;
end;

procedure TMDataSetProxy.AfterConstruction;
begin
  inherited;
  FPropList := TMPropList.Create( Self );
  _AddRef( );
end;

procedure TMDataSetProxy.SerializeRead(Ser: IMSerializer);
Var
    i, aCount : Integer;
begin
    aCount := Ser.ReadValueCount( );
    For i := 0 To aCount - 1 Do
    Begin
        FDataSet.Append( );
        Ser.ReadObject( Self );
        EndEdit( );
    End;
    FDataSet.First;
end;

procedure TMDataSetProxy.SerializeWrite(Ser: IMSerializer);
Var
    n : Integer;
begin
    n := 0;
    If ( Ser.NeedCount ) Then
        n := DoGetRecordCount;
    Ser.WriteValueCount( n );
    While ForEach Do
        Ser.WriteObject( Self );
end;

procedure TMDataSetProxy.BeginEdit;
begin
    If ( FDataSet.State <> dsEdit ) AND ( FDataSet.State <> dsInsert ) Then
        FDataSet.Edit;
end;

procedure TMDataSetProxy.EndEdit;
begin
    If ( FDataSet.State = dsEdit ) OR ( FDataSet.State = dsInsert ) Then
        FDataSet.Post;
end;

function TMDataSetProxy.GetInteger(aIndex: Integer): Integer;
begin
    Result := FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsInteger;
end;

function TMDataSetProxy.GetFloat(aIndex: Integer): Double;
begin
    Result := FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsFloat;
end;

function TMDataSetProxy.GetString(aIndex: Integer): String;
begin
    Result := FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsString;
end;

function TMDataSetProxy.GetVariant(aIndex: Integer): Variant;
begin
    Result := FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsVariant;
end;

function TMDataSetProxy.GetFields(aName: String): Variant;
begin
    Result := FDataSet.FieldByName( aName ).AsVariant;
end;

procedure TMDataSetProxy.SetInteger(aIndex, aValue: Integer);
begin
    BeginEdit;
    FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsInteger := aValue;
end;

procedure TMDataSetProxy.SetFloat(aIndex: Integer; aValue: Double);
begin
    BeginEdit;
    FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsFloat := aValue;
end;

procedure TMDataSetProxy.SetString(aIndex: Integer; aValue: String);
begin
    BeginEdit;
    FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsString := aValue;
end;

procedure TMDataSetProxy.SetVariant(aIndex: Integer; aValue: Variant);
begin
    BeginEdit;
    FDataSet.FieldByName( FPropList.PropNames[aIndex] ).AsVariant := aValue;
end;

procedure TMDataSetProxy.SetFields(aName: String; const Value: Variant);
begin
    BeginEdit;
    FDataSet.FieldByName( aName ).AsVariant := Value;
end;

function TMDataSetProxy.ForEach: Boolean;
begin
    Result := Not FDataSet.Eof;
    If FLooping Then
    Begin
        EndEdit;
        FDataSet.Next;
        Result := Not FDataSet.Eof;
        If Not Result Then
        Begin
            FDataSet.First;
            FLooping := false;
        End;
    End
    Else If Result Then
        FLooping := true;
end;

function TMDataSetProxy.DoGetRecordCount: Integer;
begin
    Result := 0;
    If Assigned( FOnGetRecordCount ) Then
        FOnGetRecordCount( Self, Result );
end;

procedure TMDataSetProxy.Free;
begin
    _Release( );
end;

end.
