(******************************************************************
DelphiDynamic Proxyʵ֡

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Jan.30-05, Feb.26, Mar.13

Aug.22  ޸TMInterfaceInvokerʵ֣ӦContainer

IMInvocationHandlerHandlerӿڡ
    Invokeĵøʽ
TMDynamicProxy̬ࡣ
TMInterfaceInvokerӿڵʵࡣ
    ͨRTTIDispatch

ҪοDelphi 7 SOAPֵTRIOTInterfaceInvokerʵ֡
ֲοJAVAеĶ̬
******************************************************************)
unit MDynPrxy;

interface

uses
  Classes, SysUtils, TypInfo, IntfInfo, MDComm, MDMethod, MSerializ;

const
  StubSize = 19;    { Max size of call stubs in the generated vtables }

type

  TMDynamicProxy = class;

  IMInvocationHandler = Interface
    Procedure Invoke( const aProxy : TMDynamicProxy;
      aContext : TMMethodInvocation );
  End;

  TMDynamicProxy = class(TObject, IInterface)
  private
    FInvHandler : IMInvocationHandler;
    FTypeInfo   : PTypeInfo;        //  Interface type info

    FInterfaceBound: Boolean;       //  VTAB thunk is generated
    FRefCount: Integer;
    IntfTable: Pointer;             { Generated vtable for the object   }
    IntfTableP: Pointer;            { Pointer to the generated vtable   }
    IntfStubs: Pointer;             { Pointer to generated vtable thunks}
    StubAddr: Pointer;              //  Current stub address
    ErrorStubAddr: Pointer;         //  Current exception address
    //IntfReg: Boolean;
    LegalCC: Boolean;
    HasRTTI: Boolean;
    { Could make these into a local object to be used by  }
    { GenVTable.  It would save space. }
    CallStub: array[0..StubSize-1] of Byte;
    CallStubIdx: Integer;

    FContext: TMMethodInvocation;

    function  Generic(CallID: Integer; Params: Pointer): Int64;
    procedure GenericStub;

    procedure ErrorEntry;

    function  GenVTable(const IID: TGUID): Boolean;

    { Mini codegenerator assist functions.  Could be bundled with }
    { CallStub in a separate object.  Maybe for next release. }
    procedure GenPushI(I: Integer);
    procedure GenDWORD(DW: LongWord);
    procedure GenByte(B: Byte);
    procedure GenRET(BytesPushed: Word = 0);

    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    { Pseudo AddRef/Release/QI.  See the comment below }
    function _AddRefFromIntf: Integer; stdcall;
    function _ReleaseFromIntf: Integer; stdcall;
    function _QIFromIntf(const IID: TGUID; out Obj): HResult; stdcall;

    procedure SetInvHandler( aValue : IMInvocationHandler );
    procedure SetTypeInfo( aValue : PTypeInfo );

  protected
    FIID: TGUID;
    IntfMD: TIntfMetaData;

    function QueryInterface(const IID: TGUID; out Obj): HResult; stdcall;

  public
    constructor Create( const aTypeInfo : PTypeInfo = Nil;
        const aInvHandler : IMInvocationHandler = Nil );
    destructor Destroy; override;

    procedure AfterConstruction; override;
    procedure BeforeDestruction; override;
    class function NewInstance: TObject; override;

    property RefCount: Integer read FRefCount;
    property InvHandler : IMInvocationHandler read FInvHandler write SetInvHandler;
    property IntfTypeInfo : PTypeInfo read FTypeInfo write SetTypeInfo;
  end;

  TMInterfaceInvoker = class( TInterfacedObject, IMMethodInterceptor )
  private
    FImpl : TObject;

    FUnk        : IInterface;
    FIntfEntry  : PInterfaceEntry;
    FIntfVTable : Pointer;
  public
    constructor Create( aImpl : TObject; aIID : TGUID ); Overload;
    destructor  Destroy; Override;

    //  Implements IMMethodInterceptor
    Procedure Invoke( const aContext : TMMethodInvocation ); Overload; Virtual;

//    class procedure Invoke(const Obj: TObject; const Context: TMMethodInvocation); overload;
  end;

implementation

uses {$IFDEF MSWINDOWS}Windows{$ENDIF}{$IFDEF LINUX}Libc{$ENDIF}, InvRules;

resourcestring
    STooManyParameters = 'Too many parameters in method %s';
    SMethNoRTTI        = 'Method has no RTTI';
    SInterfaceNoRTTI   = 'Interface has no RTTI, UUID = %s';
    SUnsupportedCCIntfMeth = 'Remote Method Call: unsupported calling convention %s for method %s on interface %s';
    SNoInterfaceGUID   = 'Class %s does not implement interface GUID %s';
    SUnsupportedCC     = 'Unsupported calling convention: %s';
    SInvInvHandler     = 'Invocation handler is invalid';

{ Common }

type
  TProc =  procedure of object;
  TObjFunc = function: Integer of Object;  stdcall;
  TQIFunc =  function(const IID: TGUID; out Obj): HResult of object; stdcall;
  PProc = ^TProc;
  TCracker = record
    case integer of
      0: (Fn: TProc);
      1: (Ptr: Pointer);
      2: (ObjFn: TObjFunc);
      3: (QIFn: TQIFunc);
    end;

{ TMDynamicProxy }

{
  Generates a PUSH immediate instruction to the call stub buffer.  If the
  immediate value fits in a byte, we encode it efficiently, otherwise
  we use the PUSH imm32 encoding.
}
procedure TMDynamicProxy.GenPushI(I: Integer);
begin
  if I < 128 then
  begin
    CallStub[CallStubIdx] := $6A;
    CallStub[CallStubIdx + 1] := I;
    Inc(CallStubIdx, 2);
  end
  else
  begin
    CallStub[CallStubIdx] := $68;
    PInteger(@CallStub[CallStubIdx + 1])^ := I;
    Inc(CallStubIdx, 5);
  end;
end;

{
  Generates a byte to the call stub buffer.
}
procedure TMDynamicProxy.GenByte(B: Byte);
begin
  CallStub[CallStubIdx] := B;
  Inc(CallStubIdx);
end;

{
  Generates a DWORD (4 bytes) to the call stub buffer.
}
procedure TMDynamicProxy.GenDWORD(DW: LongWord);
begin
{$R-}
  CallStub[CallStubIdx] := DW;
{$R+}
  PLongWord(@CallStub[CallStubIdx])^ := DW;
  Inc(CallStubIdx, 4);
end;

{
  Generates a return instruction to the call stub buffer .  If BytesPushed
  is 0, then we generate a one byte return.  Otherwise, we generate the
  3 byte encoding.
}
procedure TMDynamicProxy.GenRET(BytesPushed: Word);
begin
  if BytesPushed > 0 then
  begin
    GenByte($C2);
    GenByte(Byte(BytesPushed and $FF));
    GenByte(Byte((BytesPushed and $FF00) shr 8));
  end
  else
    GenByte($C3);
end;

const
  NumEntriesInIInterface = 3; { QI, AddRef, Release }

function TMDynamicProxy.GenVTable(const IID: TGUID): Boolean;
var
  //Info: Pointer;
  I, J, BytesPushed: Integer;
  VTable: PPointer;
  Thunk: Pointer;
  P: PByte;
  Crack: TCracker;
begin
  { Assume success }
  Result := True;
  FIID := IID;

  //Info := InvRegistry.GetInterfaceTypeInfo(IID);
  //if Info = nil then
(*
  If FTypeInfo = Nil Then
  begin
    Result := False;
    IntfReg := False;
    Exit;
  end else
    IntfReg := True;
*)
  { Can we get RTTI for this interface? }
  try
    GetIntfMetaData(FTypeInfo{Info}, IntfMD, True);
  except
    Result := false;
    HasRTTI := False;
    Exit;
  end;
  HasRTTI := True;

  { Check to make sure that we don't have a bad calling convention in here. }
  { TO-DO: Should we check for unsupported types, parameter qualifiers
          ( i.e. do we support untyped params ? ),
          Also, what is checked here and what is checked in the IOPConvert methods ? }
  LegalCC := True;
  for I := 0 to Length(IntfMD.MDA) -1 do
  begin
    if IntfMD.MDA[I].HasRTTI then
      with IntfMD.MDA[I]  do
        if CC in [ccReg {, ccSafeCall} ] then
        begin
          Result := False;
          LegalCC := False;
          Exit;
        end;
  end;

  Crack.Fn := GenericStub;
  StubAddr := Crack.Ptr;

  Crack.Fn := ErrorEntry;
  ErrorStubAddr := Crack.Ptr;

  { Allocate two blocks - one for the vtable itself, one for }
  { the thunks. }
  GetMem(IntfTable, (Length(IntfMD.MDA) + NumEntriesInIInterface) * 4);
  IntfTableP := @IntfTable;
  GetMem(IntfStubs, (Length( IntfMD.MDA) + NumEntriesInIInterface) * StubSize );

  { Load the IUnknown vtable entries }
  VTable := PPointer(IntfTable);
  Crack.QIFn := _QIFromIntf;
  VTable^ := Crack.Ptr;
  IncPtr(VTable, 4);
  Crack.ObjFn := _AddRefFromIntf;
  VTable^ := Crack.Ptr;
  IncPtr(VTable, 4);
  Crack.ObjFn := _ReleaseFromIntf;
  VTable^ := Crack.Ptr;
  IncPtr(VTable, 4);

  { Skip over the IInterface entries }
  VTable := AddPtr(IntfTable, NumEntriesInIInterface * 4);

  Thunk := AddPtr(IntfStubs, NumEntriesInIInterface * StubSize);

  { Now walk all the interface entries, and generate vtable thunks }
  for I := NumEntriesInIInterface to Length(IntfMD.MDA) - 1 do
  begin
    { Reset the call stub buffer }
    CallStubIdx := 0;

    if not IntfMD.MDA[I].HasRTTI then
    begin
      { Generate the CALL [mem] to the error stub }
      GenByte($FF);  { FF15xxxxxxxx Call [mem]    }
      GenByte($15);
      Crack.Fn := ErrorEntry;
      GenDWORD(LongWord(@ErrorStubAddr));
    end else
    begin
      { PUSH the method ID }
      GenPushI(I);

      { PUSH the info about return value location }
      if RetOnStack(IntfMD.MDA[I].ResultInfo)  then
      begin
        if IntfMD.MDA[I].CC in [ccStdcall, ccCdecl] then
          GenPushI(2)
        else
          GenPushI(1);
      end
      else
        GenPushI(0);

      { Generate the CALL [mem] to the generic stub }
      GenByte($FF);  { FF15xxxxxxxx Call [mem] }
      GenByte($15);
      GenDWORD(LongWord(@StubAddr));

      { Generate the return sequence }
      if IntfMD.MDA[I].CC in [ccCdecl] then
      begin
        { For cdecl calling convention, the caller will do the cleanup, so  }
        { we convert to a regular ret. }
        GenRet;
      end
      else
      begin
        { For all other calling conventions, the callee is supposed to do cleanup.  }
        { Figure out how many bytes we pushed in parameters, and clean it all up.   }
        BytesPushed := 0;
        for J := 0 to IntfMD.MDA[I].ParamCount - 1 do
        begin
           if IsParamByRef(IntfMD.MDA[I].Params[J].Flags, IntfMD.MDA[I].Params[J].Info, IntfMD.MDA[I].CC) then
             Inc(BytesPushed, 4)
           else
             Inc(BytesPushed, GetStackTypeSize(IntfMD.MDA[I].Params[J].Info, IntfMD.MDA[I].CC ));
        end;
        Inc(BytesPushed, GetStackTypeSize(IntfMD.MDA[I].SelfInfo, IntfMD.MDA[I].CC ));
        { TO-DO: Investigate why not always 4 ?? }
        if RetOnStack(IntfMD.MDA[I].ResultInfo) or (IntfMD.MDA[I].CC = ccSafeCall) then
          Inc(BytesPushed, 4);

        if BytesPushed > 252 then
          raise Exception.CreateFmt(STooManyParameters, [IntfMD.MDA[I].Name]);

        GenRET(BytesPushed);
      end;
    end;
    { Copy as much of the stub that we initialized over to the  }
    { block of memory we allocated. }
    P := PByte(Thunk);
    for J := 0 to CallStubIdx - 1 do
    begin
      P^ := CallStub[J];
      IncPtr(P);
    end;

    { And then fill the remainder with INT 3 instructions for             }
    { cleanliness and safety.  If we do the allocated more smartly, we    }
    { can remove all the wasted space, except for maybe alignment.        }
    for J := CallStubIdx to StubSize - 1 do
    begin
      P^ := $CC;
      IncPtr(P);
    end;

    { Finally, put the new thunk entry into the vtable slot.  }
    VTable^ := Thunk;
    IncPtr(VTable, 4);
    IncPtr(Thunk, StubSize);
  end;
end;

constructor TMDynamicProxy.Create( const aTypeInfo : PTypeInfo;
  const aInvHandler : IMInvocationHandler );
begin
  FInterfaceBound := False;
  FContext := TMMethodInvocation.Create;

  FInvHandler := aInvHandler;
  FTypeInfo := aTypeInfo;
end;

destructor TMDynamicProxy.Destroy;
begin
  if Assigned( IntfTable ) then
    FreeMem(IntfTable);
  if Assigned( IntfStubs ) then
    FreeMem(IntfStubs);
  if Assigned( FContext ) then
    FContext.Free;
  FInvHandler := Nil;  //  InvHandler will be free
  inherited;
end;

procedure TMDynamicProxy.AfterConstruction;
begin
  { Release the constructor's implicit refcount }
  //InterlockedDecrement(FRefCount);
end;

procedure TMDynamicProxy.BeforeDestruction;
begin
  inherited;
{ TO-DO: Inform user of incorrect usage - object deleted before refCount reaches 0.
  if FRefCount <> 0 then
    raise Exception.Create(SInvalidPointer);
}
end;

{ Set an implicit refcount so that refcounting  }
{ during construction won't destroy the object. }

class function TMDynamicProxy.NewInstance: TObject;
begin
  Result := inherited NewInstance;
  TMDynamicProxy(Result).FRefCount := 1;
end;

{
  This function, and TRIO._ReleaseFromIntf below, are both anomalies.  They will
  not participate in reference counting as you would normally expect of
  interfaced objects, because we prevent the normal interfaces from being
  acquired from this object in our implementation of QueryInterface.
  Whenever we enter these implementations of AddRef and Release, our
  interface pointers are not the normal interface pointers that have been
  properly adjusted by the compiler/RTL, but our generated interface
  pointers.  So we adjust these in our implementation to save space.
  The implication is that we cannot ever call these functions directly
  from our member functions, or from any derived members.  That's the
  reason that they're in the private section.
}
function TMDynamicProxy._AddRefFromIntf: Integer;
begin
  { Adjust the self pointer to point to the actual object, not  }
  { our little generated vtable slot. }
  Self := AddPtr(Self, -Integer(LongWord(@Self.IntfTable) - LongWord(Self)));
  Result := InterlockedIncrement(FRefCount);
end;

function TMDynamicProxy._ReleaseFromIntf: Integer;
begin
  { Adjust the self pointer to point to the actual object, not  }
  { our little generated vtable slot.                           }
  Self := AddPtr(Self, -Integer(LongWord(@Self.IntfTable) - LongWord(Self)));
  Result := InterlockedDecrement(FRefCount);
  if (Result = 0) {and not (Owner is TComponent)} then
    Destroy;
end;

function TMDynamicProxy._QIFromIntf(const IID: TGUID; out Obj): HResult;
begin
  { Adjust the self pointer to point to the actual object, not  }
  { our little generated vtable slot.                           }
  Self := AddPtr(Self, -Integer(LongWord(@Self.IntfTable) - LongWord(Self)));
  { Access to IInterface interfaces }
  if IsEqualGUID(IID, IInterface) then
  begin
    Result := Self.QueryInterface(IID, Obj);
    Exit;
  end;

  if (Self.FInterfaceBound) and
     IsEqualGUID(Self.FIID, IID) then
  begin
    Result := Self.QueryInterface(IID, Obj);
    Exit;
  end;

  Result := E_NOINTERFACE;
end;

function TMDynamicProxy.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  Result := E_NOINTERFACE;

  { IInterface }
  if IsEqualGUID(IID, IInterface) then
  begin
    if GetInterface(IID, Obj) then
      Result := 0;
    Exit;
  end;

  if FInterfaceBound then
  begin
    if IsEqualGuid(FIID, IID) then
    begin
      Result := 0;
      Pointer(Obj) := IntfTableP;
      InterlockedIncrement(FRefCount);
    end;
  end
  else
  begin
    if GenVTable(IID) then
    begin
      Result := 0;
      FInterfaceBound := True;
      Pointer(Obj) := IntfTableP;
      InterlockedIncrement(FRefCount);
    end;
  end;
end;

function TMDynamicProxy._AddRef: Integer;
begin
  Result := InterlockedIncrement(FRefCount);
end;

function TMDynamicProxy._Release: Integer;
begin
  Result := InterlockedDecrement(FRefCount);
  if (Result = 0) {and not (Owner is TComponent)} then
    Destroy;
end;

{ Assumes jmp to TRIO.Generic has register calling convention and
  the params are:
     eax: self (of a TRIO instance)
     edx: method # in interface
     ecx: address on stack of start of the params & return }
procedure TMDynamicProxy.GenericStub;
asm
        POP     EAX  { Return address in runtime generated stub }
        POP     EDX  { Is there a pointer to return structure on stack and which CC is used?  }
        CMP     EDX, 2
        JZ      @@RETONSTACKRL
        CMP     EDX, 1
        JZ      @@RETONSTACKLR
        POP     EDX           { Method # pushed by stub  }
        PUSH    EAX           { Push back return address }
        LEA     ECX, [ESP+12] { Calc stack pointer to start of params }
        MOV     EAX, [ESP+8]  { Calc interface instance ptr }
        JMP     @@CONT
@@RETONSTACKLR:
        POP     EDX           { Method # pushed by stub   }
        PUSH    EAX           { Push back return address  }
        LEA     ECX, [ESP+12] { Calc stack pointer to start of params }
        MOV     EAX, [ESP+8]  { Calc interface instance ptr }
        JMP     @@CONT
@@RETONSTACKRL:
        POP     EDX           { Method # pushed by stub  }
        PUSH    EAX           { Push back return address }
        LEA     ECX, [ESP+8]  { Calc stack pointer to start of params }
        MOV     EAX, [ESP+12] { calc interface instance ptr }
@@CONT:
        SUB     EAX, OFFSET TMDynamicProxy.IntfTable;  { Adjust intf pointer to object pointer }
        JMP     TMDynamicProxy.Generic
end;

{
  LoadFloatReturn

  Handles the nuances of getting the various different sized floating
  point values from a buffer and onto the FPU for retrieval by the
  caller.
}
procedure LoadFloatReturn(RetP: Pointer; FloatType: TFloatType);
asm
        CMP     EDX, ftSingle
        JE      @@Single
        CMP     EDX, ftDouble
        JE      @@Double
        CMP     EDX, ftExtended
        JE      @@Extended
        CMP     EDX, ftCurr
        JE      @@Curr
        CMP     EDX, ftComp
        JE      @@Curr      { Same as Curr }
        { Should never get here!! }
@@Single:
        FLD     DWORD PTR [EAX]
        RET
@@Double:
        FLD     QWORD PTR [EAX]
        RET
@@Extended:
        FLD     TBYTE PTR [EAX]
        RET
@@Curr:
        FILD    QWORD PTR [EAX]
end;

function TMDynamicProxy.Generic(CallID: Integer; Params: Pointer): Int64;
Var
  i : Integer;
  RetP : Pointer;
begin
  Result := Int64(0);

  { Here provide error about failure at GenVTable time - note: This is because
    a QueryInterface call cannot throw an exception with useful error message;
    so in order to be programmer-friendly we act as if the QI succeeded and then
    we throw a more descriptive error on the first call }
  //if not IntfReg then
    //raise Exception.CreateFmt(SInterfaceNotReg, [GuidToString(FIID)]);
  if not HasRTTI then
    raise Exception.CreateFmt(SInterfaceNoRTTI, [GuidToString(FIID)]);

  if not LegalCC then
  begin
    for I := 0 to Length(IntfMD.MDA) -1 do
    begin
      if IntfMD.MDA[I].HasRTTI then
        with IntfMD.MDA[I] do
          if CC in [ccReg {, ccSafeCall} ] then
            raise Exception.CreateFmt(SUnsupportedCCIntfMeth, [CallingConventionName[CC], Name, IntfMD.Name]);
    end;
  end;

  FContext.GenContext( IntfMD, CallID, Params, @Result );

  If Assigned( FInvHandler ) Then
    FInvHandler.Invoke( Self, FContext )
  Else
    Raise Exception.Create(SInvInvHandler);

  With FContext Do
  Begin
    RetP := RetPtr;

    if (MethMD.CC <> ccSafeCall) and
       (MethMD.ResultInfo <> nil) and
       (MethMD.ResultInfo.Kind = tkFloat) then
      LoadFloatReturn(RetP, GetTypeData(MethMD.ResultInfo).FloatType);

    if (MethMD.ResultInfo <> nil) and (MethMD.ResultInfo.Kind = tkInt64) then
    begin
      asm
         PUSH   ECX
         MOV    ECX, DWORD PTR [RetP]
         MOV    EAX, DWORD PTR [ECX]
         MOV    EDX, DWORD PTR [ECX + 4]
         POP    ECX
      end;
    end;

    if MethMD.CC = ccSafeCall then
    asm
      XOR EAX, EAX  { TO-DO: handle safecall exceptions... }
      MOV DWORD PTR Result, EAX
    end;
    asm CLD end;

  End;
end;

procedure TMDynamicProxy.ErrorEntry;
begin
  raise Exception.Create(SMethNoRTTI);
end;

procedure TMDynamicProxy.SetInvHandler( aValue : IMInvocationHandler );
begin
  If Not FInterfaceBound Then
    FInvHandler := aValue;
end;

procedure TMDynamicProxy.SetTypeInfo( aValue : PTypeInfo );
begin
  If Not FInterfaceBound Then
    FTypeInfo := aValue;
end;

{ TMInterfaceInvoker }

constructor TMInterfaceInvoker.Create(aImpl: TObject; aIID : TGUID);
begin
  Inherited Create;
  FImpl := aImpl;

  if not FImpl.GetInterface(aIID, FUnk) then
    raise Exception.CreateFmt(SNoInterfaceGUID,
      [FImpl.ClassName, GUIDToString(aIID)]);

  FIntfEntry  := FImpl.GetInterfaceEntry(aIID);
  FIntfVTable := FIntfEntry.VTable;
end;

destructor TMInterfaceInvoker.Destroy;
begin
    inherited;
end;

{
  PushStackParm

  Copies an aligned number of bytes specified by ByteCount from the Parm
  to the current stack.  N.B.  We leave the bytes on the stack when we
  exit!

  Stack parameters come in many different sizes, ranging from 4 bytes to
  16 bytes.  This function copies a parameter of arbitrary
  size from a prior stack location (assumed the stack), onto the current
  stack.  On exit, we leave the additional bytes on the stack.  We use this
  to build the parameter list to the server side functions.

  We don't have to worry about copying bytes at the end of a page, because
  we assume that Parm is pointing to something higher up on the stack, and
  aligned on a proper stack boundary.
}
procedure PushStackParm(Parm: Pointer; ByteCount: Integer);
asm
        {
          EAX -> Parm (the parameter to be copied)
          EDX -> ByteCount (the number of bytes of data in Parm)
        }
        { We just use a jump table to copy the bits }
        LEA     ECX, @JT
{$IFDEF PIC}
        ADD     ECX, EBX
        ADD     ECX, EDX        // Assume that ByteCount is a DWORD multiple
        POP     EDX             // Remove and save the return address
        MOV     ECX, [ECX]
        ADD     ECX, EBX
        JMP     ECX
{$ELSE}
        ADD     ECX, EDX        // Assume that ByteCount is a DWORD multiple
        POP     EDX             // Remove and save the return address
        JMP     [ECX]
{$ENDIF}
@L4:
        PUSH    [EAX+12]
@L3:
        PUSH    [EAX+8]
@L2:
        PUSH    [EAX+4]
@L1:
        PUSH    [EAX]
        PUSH    EDX             // Push back the saved ret addr
        RET                     // All done
@JT:
        DD  0                   // 0 bytes (never happens)
        DD  @L1                 // 4 bytes
        DD  @L2                 // 8 bytes
        DD  @L3                 // 12 bytes
        DD  @L4                 // 16 bytes
end;

{
  GetFloatReturn

  Handles the nuances of retrieving the various different sized floating
  point values from the FPU and storing them in a buffer.
}
procedure GetFloatReturn(RetP: Pointer; FloatType: TFloatType);
asm
        CMP     EDX, ftSingle
        JE      @@Single
        CMP     EDX, ftDouble
        JE      @@Double
        CMP     EDX, ftExtended
        JE      @@Extended
        CMP     EDX, ftCurr
        JE      @@Curr
        CMP     EDX, ftComp
        JE      @@Curr      { Same as Curr  }
        { Should never get here :) }
@@Single:
        FSTP      DWORD PTR [EAX]
        WAIT
        RET
@@Double:
        FSTP      QWORD PTR [EAX]
        WAIT
        RET
@@Extended:
        FSTP      TBYTE PTR [EAX]
        WAIT
        RET
@@Curr:
        FISTP     QWORD PTR [EAX]
        WAIT
end;

//class procedure TMInterfaceInvoker.Invoke(const aObj: TObject;
//  const aContext: TMMethodInvocation);
procedure TMInterfaceInvoker.Invoke(const aContext : TMMethodInvocation);
var
  MethPos: Integer;
  RetIsOnStack, RetIsInFPU, RetInAXDX: Boolean;
  I: Integer;
  RetP : Pointer;
  MD : TIntfMethEntry;
  DataP: Pointer;
  Temp, Temp1: Integer;
  RetEAX: Integer;
  RetEDX: Integer;
  TotalParamBytes: Integer;
  ParamBytes: Integer;
begin
  TotalParamBytes := 0;
  // TODO: if aContext
  MD := aContext.MethMD;
  MethPos := MD.Pos * 4; { Pos is absolute to whole VMT }
  if MD.ResultInfo <> nil then
  begin
    RetIsInFPU := RetInFPU(MD.ResultInfo);
    RetIsOnStack := RetOnStack(MD.ResultInfo);
    RetInAXDX := IsRetInAXDX(MD.ResultInfo);
    RetP := aContext.RetPtr;
  end else
  begin
    RetIsOnStack := False;
    RetIsInFPU := False;
    RetInAXDX := False;
  end;

  if MD.CC in [ccCDecl, ccStdCall, ccSafeCall] then
  begin
    if (MD.ResultInfo <> nil) and (MD.CC = ccSafeCall) then
      asm PUSH DWORD PTR [RetP] end;
    for I := MD.ParamCount - 1 downto 0 do
    begin
      DataP := aContext.ParamPtrs[I];
//  λӰVar
//      if IsParamByRef(MD.Params[I].Flags,MD.Params[I].Info, MD.CC) then
//      asm
//        PUSH DWORD PTR [DataP]
//      end
//      else
      begin
        ParamBytes := GetStackTypeSize(MD.Params[I].Info, MD.CC);
        PushStackParm(DataP, ParamBytes);
        Inc(TotalParamBytes, ParamBytes);
      end;
    end;
    asm PUSH DWORD PTR [FUnk] end;
    if RetIsOnStack and (MD.CC <> ccSafeCall) then
      asm PUSH DWORD PTR [RetP] end;
  end
  else if MD.CC = ccPascal then
  begin
    for I := 0 to MD.ParamCount - 1 do
    begin
      DataP := aContext.ParamPtrs[I];
      if IsParamByRef(MD.Params[I].Flags,MD.Params[I].Info, MD.CC) then
      asm
         PUSH DWORD PTR [DataP]
      end
      else
      begin
//        PushStackParm(DataP, GetStackTypeSize(MD.Params[I].Info, MD.CC));
        ParamBytes := GetStackTypeSize(MD.Params[I].Info, MD.CC);
        PushStackParm(DataP, ParamBytes);
        Inc(TotalParamBytes, ParamBytes);
      end;
    end;
    if RetIsOnStack then
      asm PUSH DWORD PTR [RetP] end;
    asm PUSH DWORD PTR [FUnk] end;
  end else
     raise Exception.CreateFmt(SUnsupportedCC, [CallingConventionName[MD.CC]]);

  if MD.CC <> ccSafeCall then
  begin
    asm
      MOV DWORD PTR [Temp], EAX
      MOV DWORD PTR [Temp1], ECX
      MOV EAX, MethPos
      MOV ECX, [FIntfVtable]
      MOV ECX, [ECX + EAX]
      CALL ECX
      MOV DWORD PTR [RetEAX], EAX
      MOV DWORD PTR [RetEDX], EDX
      MOV EAX, DWORD PTR [Temp]
      MOV ECX, DWORD PTR [Temp1]
    end;
  end else
  begin
    asm
      MOV DWORD PTR [Temp], EAX
      MOV DWORD PTR [Temp1], ECX
      MOV EAX, MethPos
      MOV ECX, [FIntfVtable]
      MOV ECX, [ECX + EAX]
      CALL ECX
      CALL System.@CheckAutoResult
      MOV DWORD PTR [RetEAX], EAX
      MOV DWORD PTR [RetEDX], EDX
      MOV EAX, DWORD PTR [Temp]
      MOV ECX, DWORD PTR [Temp1]
    end;
  end;

  // If we're cdecl, we're responsible for cleanup up the stack.
  if MD.CC = ccCDecl then
  asm
    MOV EAX, DWORD PTR [TotalParamBytes]
    ADD ESP, EAX
  end;

  if MD.ResultInfo <> nil then
  begin
    if MD.CC <> ccSafeCall then
    begin
      if RetIsInFPU then
      begin
        GetFloatReturn(RetP, GetTypeData(MD.ResultInfo).FloatType);
      end else if not RetIsOnStack then
      begin
        if RetInAXDX then
        asm
            PUSH EAX
            PUSH ECX
            MOV EAX, DWORD PTR [RetP]
            MOV ECX, DWORD PTR [RetEAX]
            MOV [EAX], ECX
            MOV ECX, DWORD PTR [RetEDX]
            MOV [EAX + 4], ECX
            POP ECX
            POP EAX
        end
        else
        asm
            PUSH EAX
            PUSH ECX
            MOV EAX, DWORD PTR [RetP]
            MOV ECX, DWORD PTR [RetEAX]
            MOV [EAX], ECX
            POP ECX
            POP EAX
        end;
      end;
    end;
  end;
end;
(*
procedure TMInterfaceInvoker.Invoke(const aContext : TMMethodInvocation);
begin
    Invoke( FImpl, aContext );
end;
*)
end.
 