(******************************************************************
Devoteeʵ

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Dec.02-07
*******************************************************************
TMInstanceManagerDefault: Ĭʵࡣ
        ʵIInstanceManagerӿڡ
*******************************************************************
Change log :
071202  IInstanceManager
071202  TMInstanceManagerDefault
071205  TMIntfRegValueTMIncptRegValueMIntfRegԪƵ
******************************************************************)
unit MInstMng;

interface

uses
  SysUtils, Classes, TypInfo, MHashMap, MIntfReg;
  //Windows, MDConst;

Type
{ TMIntfRegValue }
  TMIntfRegValue = class( TMValueObject )
  private
    FTypeInfo : PTypeInfo;
    FObjClass : TClass;
    FConfig   : IInterface;
  public
    constructor Create( aTypeInfo : PTypeInfo; aObjClass : TClass;
      aConfig : IInterface );

    function NewObject : TObject;

    property TypeInfo : PTypeInfo  read FTypeInfo;
    property Config   : IInterface read FConfig;
  end;

{ TMIntcptRegValue }
  TMIntcptRegValue = class( TMValueObject )
  private
    FObjClass : TClass;
    FRefCount : Integer;
  public
    constructor Create( aObjClass : TClass );

    function NewObject : TObject;
  end;

  IMInstanceManager = interface
    Procedure RegisterIntf(   const aIID : TGUID; const aTypeInfo : PTypeInfo;
        const aObjectClass : TClass; aConfig : IInterface );
    Procedure UnregisterIntf( const aIID : TGUID );
    Function  GetObject(   const aIID : TGUID ) : TObject;
    Function  GetInstance( const aIID : TGUID ) : IInterface;
    Function  GetRegValue( const aIID : TGUID ) : TMIntfRegValue;
  End;

  TMInstanceManagerDefault = class( TInterfacedObject, IMInstanceManager )
  private
    FIntfMap : TMHashMap;
  public
    Constructor Create;
    Destructor  Destroy; Override;
    //  Implements IMInstanceManager
    Procedure RegisterIntf(   const aIID : TGUID; const aTypeInfo : PTypeInfo;
        const aObjectClass : TClass; aConfig : IInterface );
    Procedure UnregisterIntf( const aIID : TGUID );
    Function  GetObject(   const aIID : TGUID ) : TObject;
    Function  GetInstance( const aIID : TGUID ) : IInterface;
    Function  GetRegValue( const aIID : TGUID ) : TMIntfRegValue;
  End;

implementation

{ TMIntfRegValue }
constructor TMIntfRegValue.Create(aTypeInfo: PTypeInfo; aObjClass: TClass;
  aConfig : IInterface);
begin
  FTypeInfo := aTypeInfo;
  FObjClass := aObjClass;
  FConfig   := aConfig;
end;

function TMIntfRegValue.NewObject: TObject;
begin
  Result := FObjClass.Create;
end;

{ TMIntcptRegValue }
constructor TMIntcptRegValue.Create( aObjClass: TClass );
begin
  FObjClass := aObjClass;
  FRefCount := 0;
end;

function TMIntcptRegValue.NewObject: TObject;
begin
  Inc( FRefCount );
  Result := FObjClass.Create;
  //  TODO: ͷʱdec refcount
end;

{ TMInstanceManagerDefault }

constructor TMInstanceManagerDefault.Create;
begin
  Inherited;
  FIntfMap := TMHashMap.Create;
end;

destructor TMInstanceManagerDefault.Destroy;
begin
  FIntfMap.Free;
  Inherited;
end;

procedure TMInstanceManagerDefault.RegisterIntf(const aIID: TGUID;
  const aTypeInfo: PTypeInfo; const aObjectClass: TClass;
  aConfig: IInterface);
begin
  FIntfMap.Add( TMGUIDKeyPair.Create( aIID,
    TMIntfRegValue.Create( aTypeInfo, aObjectClass, aConfig ) ) );
end;

procedure TMInstanceManagerDefault.UnregisterIntf(const aIID: TGUID);
begin
  FIntfMap.Delete( TMGUIDKeyPair.Create( aIID, Nil ) );
end;

function TMInstanceManagerDefault.GetObject(const aIID: TGUID): TObject;
begin
  Result := GetRegValue( aIID ).NewObject( );
end;

function TMInstanceManagerDefault.GetInstance(const aIID: TGUID): IInterface;
begin
  Supports( GetObject( aIID ), IInterface, Result );
end;

function TMInstanceManagerDefault.GetRegValue(
  const aIID: TGUID): TMIntfRegValue;
begin
  Result := FIntfMap.Find( TMGUIDKeyPair.Create( aIID, Nil ) ).Value
    As TMIntfRegValue;
end;

end.
