(******************************************************************
Devoteeİ

Copyright (C) 2005, 07 by raptor.zh@gmail.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

website: http://mental.we8log.com
blog   : http://blog.csdn.net/raptor
Rev.   : Mar.13, Apr.21-05, Dec.02-07
*******************************************************************
TMPackageManager: ࡣ
        ĴԭTMInterfaceRegistry
TMPackageLoaderࡣ
        ʵֲοwr960204()(2003-2-20)Ķ̬
        PackageĴ
*******************************************************************
Change log :
050723  ԭĽӿעֳɽӿעӿںͰ֡
050731  ޸Ĺ캯ʵֹ֣ȷصáӷֹظͬ
        Package⡣ӸݽӿȡýӿIDķ
050819  Ϊõİʵ֣ʹHackķʽ
        ӿעϢaConfigXMLStringʽʵ֡
050826  ȡݵGetIntfConfig
071202  TMIntfRegValueTMIntcptRegValueƵInterfaceRegistryԪ
071202  ʵܽӿڡ
071205  FIntfMapƵMInstMngԪ
******************************************************************)
unit MPkgMngr;

interface

uses
  SysUtils, Classes, TypInfo, Windows, MHashMap, MIntfReg, MDConst, MInstMng;

Type
  TMGenerateConfigEvent = Procedure ( Sender : TObject; aString : String;
    Var aConfig : IInterface ) Of Object;

  TMPackageLoader = class;

  TMPackageManager = class( TInterfacedObject, IMInterfaceRegistry )
  private
    FPkgList : TList;
    FIntfName: TStrings;

    FIntcpts : TStrings;

    FCurPkg  : TMPackageLoader;

    FGenConfig : TMGenerateConfigEvent;

    FInstMngr : IMInstanceManager;

    constructor Create( aInstMngr : IMInstanceManager ); Overload;
    function GetPackages(aIndex: Integer): TMPackageLoader;
    function FindPackageByHandle( aHandle : THandle ) : TMPackageLoader;
  public
    constructor Create; Overload;
    destructor Destroy; Override;
    class function Instance : TMPackageManager;

    //  Implements IMInterfaceRegistry
    Function  GetIntfTypeInfo( const aIID : TGUID ) : PTypeInfo;
    Function  GetIntfObject( const aIID : TGUID ) : TObject;
    Function  GetIntfInstance( const aIID : TGUID ) : IInterface;
    Function  GetIntfAnnotation( const aIID : TGUID ) : IInterface;
    Procedure RegisterIntf( const aIID : TGUID; const aTypeInfo : PTypeInfo;
        const aObjectClass : TClass; aConfig : String );
    Procedure UnregisterIntf( const aIID : TGUID );
    Procedure RegisterInterceptor( const aName : ShortString;
      const aInterceptorClass : TClass );
    Procedure UnregisterInterceptor( const aName : ShortString );

    Procedure Clear;
    Procedure Free;
    Procedure AddPackage( aPackageName : String );
    Procedure DelPackage( aPackage : TMPackageLoader );
    Function  GetIntfID( aIntfName : String ) : TGUID;

    property InstanceManager : IMInstanceManager Read FInstMngr;
    property Packages[aIndex : Integer] : TMPackageLoader Read GetPackages;

    property OnGenConfig : TMGenerateConfigEvent Read FGenConfig Write FGenConfig;
  End;

  TMPackageLoader = class
  private
    FOwner    : TMPackageManager;
    FIntfList : Array Of TGUID;
    FIndex    : Integer;
    FSize     : Integer;

    FIntcpts  : TStrings;

    FPkgName  : String;
    FHandle   : THandle;
    FUnitList : TStrings;

    Procedure RegisterIntf(const aIID: TGUID);
    Procedure RegisterIntcpt( const aName : ShortString );
  public
    constructor Create( aOwner : TMPackageManager );
    destructor Destroy; Override;

    Procedure Clear;
    Function LoadPackage( aPackageName : String ) : Boolean;

    property PackageName : String  Read FPkgName;
    property Handle      : THandle Read FHandle;
  End;

implementation

Const
  cnVectSize = 100;
  cnVectInc  = 20;

Var
  _GMIntfReg : TMPackageManager;

{ TMPackageManager }

constructor TMPackageManager.Create( aInstMngr : IMInstanceManager );
begin
  Inherited Create;
  FPkgList := TList.Create;
  FIntfName:= TStringList.Create;
  FIntcpts := TStringList.Create;
  FCurPkg  := Nil;
  If Assigned( aInstMngr ) Then
    FInstMngr := aInstMngr
  Else
    FInstMngr:= TMInstanceManagerDefault.Create;
end;

constructor TMPackageManager.Create;
begin
   Inherited;
   Raise Exception.Create( csrSingleton );
end;

destructor TMPackageManager.Destroy;
begin
  Clear;
  FInstMngr := Nil; // auto free
  FIntcpts.Free;
  FIntfName.Free;
  FPkgList.Free;
  inherited;
end;

class function TMPackageManager.Instance: TMPackageManager;
begin
  Result := _GMIntfReg;
end;

procedure TMPackageManager.Clear;
Var
  i : Integer;
begin
  For i := FPkgList.Count - 1 DownTo 0 Do
  Begin
    TMPackageLoader( FPkgList.Items[i] ).Free;
    FPkgList.Items[i] := Nil;
  End;
  FPkgList.Clear;
end;

procedure TMPackageManager.Free;
begin
  _Release;
end;

function TMPackageManager.GetPackages(aIndex: Integer): TMPackageLoader;
begin
  Result := TMPackageLoader( FPkgList.Items[aIndex] );
end;

procedure TMPackageManager.AddPackage(aPackageName: String);
begin
  FCurPkg := TMPackageLoader.Create( Self );
  If ( FCurPkg.LoadPackage( aPackageName ) ) Then
    FPkgList.Add( Pointer( FCurPkg ) )
  Else
    FCurPkg.Free;
  FCurPkg := Nil;
end;

procedure TMPackageManager.DelPackage(aPackage: TMPackageLoader);
Var
  i : Integer;
begin
  i := FPkgList.IndexOf( Pointer( aPackage ) );
  If ( i >= 0 ) Then
  Begin
    TMPackageLoader( FPkgList.Items[i] ).Free;
    FPkgList.Items[i] := Nil;
    FPkgList.Delete( i );
  End;
end;

function TMPackageManager.GetIntfAnnotation(const aIID: TGUID): IInterface;
begin
  Result := FInstMngr.GetRegValue( aIID ).Config;
end;

function TMPackageManager.GetIntfInstance(const aIID: TGUID): IInterface;
begin
  Supports( GetIntfObject( aIID ), IInterface, Result );
end;

function TMPackageManager.GetIntfObject(const aIID: TGUID): TObject;
begin
  Result := FInstMngr.GetObject( aIID );
end;

function TMPackageManager.GetIntfTypeInfo(const aIID: TGUID): PTypeInfo;
begin
  Result := FInstMngr.GetRegValue( aIID ).TypeInfo;
end;

procedure TMPackageManager.RegisterIntf(const aIID: TGUID;
  const aTypeInfo: PTypeInfo; const aObjectClass: TClass; aConfig : String);
Var
  cfg : IInterface;
begin
  If Assigned( FGenConfig ) Then
  Begin
    Try
      // TODO: cfg ˴˽ӿзãinterceptors
      FGenConfig( Self, aConfig, cfg );
    Except
      cfg := Nil;
    End;
  End;
  FInstMngr.RegisterIntf( aIID, aTypeInfo, aObjectClass, cfg );
  FIntfName.AddObject( aTypeInfo^.Name, TObject( @aIID ) );
  If Assigned( FCurPkg ) Then
    FCurPkg.RegisterIntf( aIID );
end;

procedure TMPackageManager.UnregisterIntf(const aIID: TGUID);
begin
  FInstMngr.UnregisterIntf( aIID );
end;

procedure TMPackageManager.RegisterInterceptor(const aName: ShortString;
  const aInterceptorClass: TClass);
begin
  FIntcpts.AddObject( aName, TMIntcptRegValue.Create( aInterceptorClass ) );
  If Assigned( FCurPkg ) Then
    FCurPkg.RegisterIntcpt( aName );
end;

procedure TMPackageManager.UnregisterInterceptor(const aName: ShortString);
Var
  i : Integer;
begin
  i := FIntcpts.IndexOf( aName );
  If ( i >= 0 ) Then
  Begin
    FIntcpts.Objects[i].Free;
    FIntcpts.Delete( i );
  End;
end;

function TMPackageManager.FindPackageByHandle(
  aHandle: THandle): TMPackageLoader;
Var
  i : Integer;
begin
  Result := Nil;
  i := FPkgList.Count - 1;
  While ( i >= 0 ) AND ( Result = Nil ) Do
  Begin
    If ( TMPackageLoader( FPkgList.Items[i] ).Handle = aHandle ) Then
        Result := TMPackageLoader( FPkgList.Items[i] );
    Dec( i );
  End;
end;

function TMPackageManager.GetIntfID(aIntfName: String): TGUID;
Var
  i : Integer;
begin
  Result := IUnknown;
  i := FIntfName.IndexOf( aIntfName );
  If ( i >= 0 ) Then
    Result := PGUID( FIntfName.Objects[i] )^;
end;

{ TMPackageLoader }

procedure PackageInfoProc(const Name: string; NameType: TNameType; Flags: Byte;
    Param: Pointer);
begin
  case NameType of
    ntContainsUnit:
      TMPackageLoader( Param ).FUnitList.Add(Name);
  end;
end;

constructor TMPackageLoader.Create( aOwner : TMPackageManager );
begin
  inherited Create;
  FOwner := aOwner;
  SetLength( FIntfList, cnVectSize );
  FIndex := 0;
  FSize  := cnVectSize;
  FIntcpts  := TStringList.Create;
  FUnitList := TStringList.Create;
end;

destructor TMPackageLoader.Destroy;
begin
  Clear;
  FUnitList.Free;
  FIntcpts.Free;
  inherited;
end;

procedure TMPackageLoader.Clear;
Var
  i : Integer;
begin
  //  TODO: ȼInterceptorδʹ
  For i := FIntcpts.Count -1 DownTo 0 Do
    FOwner.UnregisterInterceptor( FIntcpts.Strings[i] );
  For i := FIndex - 1 DownTo 0 Do
    FOwner.UnregisterIntf( FIntfList[i] );
  FIndex := 0;
  If ( FHandle <> 0 ) Then
  Begin
    UnloadPackage( FHandle );
    FPkgName := '';
    FHandle  := 0;
    FUnitList.Clear;
  End;
end;

Function TMPackageLoader.LoadPackage(aPackageName: String) : Boolean;

    Function FormatUnitName( aUnitName : String ) : String;
    Begin
        Result := UpCase( aUnitName[1] )
            + LowerCase( Copy( aUnitName, 2, Length( aUnitName ) ) );
    End;

Var
  i : Integer;
  sProcName : String;
  funcReg : TProcedure;
begin
  Result   := true;
  FPkgName := aPackageName;
  FHandle  := SysUtils.LoadPackage( aPackageName );
  If Assigned( FOwner.FindPackageByHandle( FHandle ) ) Then
    Result := false
  Else
  Begin
    GetPackageInfo( FHandle, Self, i, PackageInfoProc );
    For i := 0 To FUnitList.Count - 1 Do
    Begin
      sProcName := '@' + FormatUnitName( FUnitList[i] ) + '@DtRegister$qqrv';
      funcReg := TProcedure( GetProcAddress( FHandle, PChar( sProcName ) ) );
      If ( Assigned( funcReg ) ) Then
        funcReg;
    End;
  End;
end;

procedure TMPackageLoader.RegisterIntf(const aIID: TGUID);
begin
  If ( FIndex >= FSize ) Then
  Begin
    FSize := FSize + cnVectInc;
    SetLength( FIntfList, FSize );
  End;
  FIntfList[FIndex] := aIID;
  Inc( FIndex );
end;

procedure TMPackageLoader.RegisterIntcpt(const aName: ShortString);
begin
  FIntcpts.Add( aName );
end;

initialization
    _GMIntfReg := TMPackageManager.Create( Nil );
    GMIntfReg  := _GMIntfReg As IMInterfaceRegistry;

finalization
    GMIntfReg := Nil;

end.
